//////////////////////////////////////////////////////////////////////////////
// common.h
//
// Prototypes of common functions to be out of the blobal definition
//////////////////////////////////////////////////////////////////////////////

#ifndef __COMMON_H__
#define __COMMON_H__

#include <stdio.h>
#ifdef USE_LINUX
#include <set>
#include <string>

using namespace std;

typedef struct  PROC_SYS_INFO
{
    int             process_id;
    unsigned int    total_mem;
    unsigned int    free_mem;
    unsigned int    memory;    
    double          sys_cpu;
    double          proc_cpu;
    std::string     state;
    std::string     cmdline;    
}PROC_SYS_INFO;

#endif

#define NORMAL_LOG_MSG          0
#define ERROR_LOG_MSG           1
#define NORMAL_SCREEN_LOG_MSG   2
#define PRIOR_LOG_MSG           3
#define AUX_PRIOR_LOG_MSG       4

#define SUMMARY_NO_SUMMARY      0
#define SUMMARY_G7              1
#define SUMMARY_VOICE           2

#ifndef FALSE
#define FALSE 0
#endif

void          COMMON_Put_Syslog_Message (int error_flag, const char *text_format, ...);
void          COMMON_Adjust_Time        (long milsec_adjust);
unsigned int  COMMON_GetTime            (void);
void          COMMON_Get_Date_Format             (char *date_str);
void          COMMON_Get_Time_Format_With_Colons (char *time_str);
void          Common_Set_Application_Path        (const char *app_path, int user_entered_path);
int           COMMON_Change_To_Initial_Directory (void);
int           COMMON_Create_Directory            (const char *dir_name);
void          COMMON_Change_User_Path_To_OS_Format (char *source_path_to_change, 
                                                    int   set_last_os_dir_separator);
long          COMMON_Get_Adjust_Time    (void);
unsigned int  COMMON_GetTime_Frc        (unsigned int *g_numerator, unsigned int *g_denominator);
unsigned int  COMMON_GetLocTime_Frc     (unsigned int *g_numerator, unsigned int *g_denominator);
void          COMMON_Output_Message     (FILE *file_output, char *buffer, int stored_buffer);
unsigned int  COMMON_Get_Crc32          (const char *ptr, int len, unsigned int start_crc32 = 0);
void          COMMON_Get_Time           (char *timebuf);
const char   *COMMON_Get_Formal_Date    (const char *value, const char *picture);
char         *COMMON_Date_Hour_Header   (char *cur_ptr, char *time_ptr);
void          COMMON_Set_Glb_DFN_Header (const char *user_code = NULL,
                                         const char *branch_code = NULL,
                                         int         especial_instit = FALSE);
#ifndef DMDIAPP
#ifndef DAPI
void          COMMON_Update_Glb_DFN_Header (void);
#endif
#endif

#ifdef USE_LINUX
#define _ASSERT(a)    
#ifdef GDIAPP
char         *COMMON_Print_CPU_Mem_Info (char *cur_ptr);
#endif
#endif
#ifdef DMDIAPP
void          COMMON_Set_Default_DMDI_DFN_Header      (void);
#endif

#endif //#ifndef __COMMON_H__


