//////////////////////////////////////////////////////////////////////////////
// restr.h
//
// Module to restrain the updating in global tables
//////////////////////////////////////////////////////////////////////////////

#ifndef __RESTR_H__
#define __RESTR_H__

#include <stdio.h>

#undef GLOBAL

#ifdef  TRANS_GLOBAL_HERE
#   define GLOBAL
#   define INIT(v) =(v)
#   define INIT_C(x)    (x)
#   define INIT_CS(x,y) (x,y)
#else
#   define GLOBAL extern
#   define INIT(v)
#   define INIT_C(x)    
#   define INIT_CS(x,y) 
#endif

#define RESTR_INSERT_ACTION   4
#define RESTR_UPDATE_ACTION   2
#define RESTR_DELETE_ACTION   1
#define RESTR_SKIP            8
#define RESTR_UPPER_VALUE     0

#define RESTR_OCUPIED_BITS    8   // leave 8 bites to be used in a future

#define RESTR_ACTIVE               1
#define RESTR_GENERATE_FULL_LOG    2

typedef enum RESTR_FORCE_ENUM
{
    RESTR_CANCEL = 1,   // 1 millisecond is a cancel
    RESTR_FORCE         // 2 millisecond in order to send restr messages when the forced restrained be cancelled.
}RESTR_FORCE_ENUM;

#ifndef DAPI
void      RESTR_Send          (CMessage *cur_msg, int table_num, int action, int target);
#endif
void      RESTR_Trans_Init    (char *buff);
void      RESTR_Trans_Cancel  (char *buff);
void      RESTR_Trans_Commit  (char *buff);
UNIX_PTR  RESTR_Do_Send       (void *ptr);

int       RESTR_Get_Table_Span(int table_num);
void      RESTR_Table_Span    (int table_num, unsigned int span_ms);
int       RESTR_Force_Table_Span (int table_num, RESTR_FORCE_ENUM  force_type);
void      RESTR_Min_Span      (unsigned int span_ms);
void      RESTR_print_str     (char *buff, FILE *file_output = NULL);
void      RESTR_Terminate     (void);
unsigned int   RESTR_Span_Status   (unsigned int span_status);

int       RESTR_Span_Switch   (void);

#undef GLOBAL
#undef INIT
#undef INIT_C
#undef INIT_CS


#endif

//////////////////////////////////////////////////////////////////////////////
